# Entry Category plugin for Movable Type
#
# Release 0.01 (Apr 15, 2008)
#
# This software is provided as-is. You may use it for commercial or
# personal use. If you distribute it, please keep this notice intact.
#
# Copyright (c) 2004-2008 Yujiro Araki
package MT::Plugin::EntryCategory;

use strict;
use base qw(MT::Plugin);

our $VERSION = '0.01';

my $plugin = MT::Plugin::EntryCategory->new ({
    name => 'Entry Category',
    description => "A plugin for the primary category of the current entry",
    doc_link => 'http://www.koikikukan.com/archives/2008/04/15-000303.php',
    version => $VERSION,
});
MT->add_plugin ($plugin);

sub init {
    my $plugin = shift;
    $plugin->SUPER::init(@_);
    my $core = MT->component('core');
    my $r = $core->registry("tags", "block");
    $r->{EntryCategory} = \&_hdlr_entry_category;
}

sub _hdlr_entry_category {
    my($ctx, $args, $cond) = @_;
    my $e = $ctx->stash('entry')
        or return $ctx->_no_entry_error($ctx->stash('tag'));
    my $cat = $e->category;
    return '' unless $cat;
    my $builder = $ctx->stash('builder');
    my $tokens = $ctx->stash('tokens');
    local $ctx->{__stash}->{category} = $cat;
    defined(my $out = $builder->build($ctx, $tokens, $cond))
        or return $ctx->error( $builder->errstr );
    $out;
}
